%% 
clear all;close all;clc
%% Load Data
mask = load('gTruth1415.mat').gTruth;
%%
summary(mask)
%% Visualize Ground Truth Box Distribution
allBoxes = vertcat(mask.Mask{:});
aspectRatio = allBoxes(:,3) ./ allBoxes(:,4);
area = prod(allBoxes(:,3:4),2);

figure
scatter(area,aspectRatio,'filled','r')
xlabel("Box Area")
ylabel("Aspect Ratio (width/height)");
title("Box Area vs. Aspect Ratio")
%% Estimate Anchor Boxes
trainingData = boxLabelDatastore(mask(:,2:end));
numAnchors = 23;
[anchorBoxes,meanIoU] = estimateAnchorBoxes(trainingData,numAnchors);
anchorBoxes
meanIoU
%%
% maxNumAnchors = 100;
% meanIoU = zeros([maxNumAnchors,1]);
% anchorBoxes = cell(maxNumAnchors, 1);
% for k = 1:maxNumAnchors
%     % Estimate anchors and mean IoU.
%     [anchorBoxes{k},meanIoU(k)] = estimateAnchorBoxes(trainingData,k);    
% end
% 
% figure
% plot(1:maxNumAnchors,meanIoU,'-o')
% ylabel("Mean IoU")
% xlabel("Number of Anchors")
% title("Number of Anchors vs. Mean IoU")